<?php
namespace Dugi;

use WPCF7_TagGenerator;
use WPCF7_Shortcode;

/**
 * @author  Dagan Yaakov <admin@dugi.co.il>
 * @since   08/12/2016
 * @update  18/07/2017
 * @link    http://wp.dugi.co.il
 * @version 1.1.0
 */


class lm_cf7_admin{
	public function __construct(){
		add_action( 'admin_init',array( $this, 'wpcf7_add_tag_generator' ),20 );
		
		//add_action( 'wpcf7_init',array( $this, 'wpcf7_add_shortcode_lm' ) );
		add_action( 'wpcf7_init',array( $this, 'wpcf7_add_form_tag_lm' ) );
	}
	
	public function wpcf7_add_tag_generator() {
		if (! class_exists('WPCF7_TagGenerator')) return ;
		$tag_generator = WPCF7_TagGenerator::get_instance();
		$tag_generator->add( 'lm', 'LeadManager', array($this,'wpcf7_tag_generator') );
	}
	
	public function wpcf7_tag_generator ($contact_form = '', $args = '') {
		$args = wp_parse_args( $args, array() );
		$type = 'lm';

		$description = __( "לעזרה ופרטים נוספים פנו ל %s", 'contact-form-7' );
		$desc_link = wpcf7_link( __( 'http://www.leadmanager.co.il/kb', 'contact-form-7' ), __( 'מרכז תמיכה', 'contact-form-7' ) );
?>
<script>
function di_extract_from_string_url(){
	ii = 0;
    var lm_sURL = document.getElementById('di_lm_sURL').value;
	if (lm_sURL.indexOf("?") > 0) {
       var lm_arrURLParams = lm_sURL.split("?")[1].split("&");
	   var lm_arrParamNames = new Array(lm_arrURLParams.length);
		for (i = 0; i < lm_arrURLParams.length; i++) {
            if (lm_arrURLParams[i].split("=")[0] == 'lm_form'){
				//js
				document.getElementById('tag-generator-panel-lm-lm_form').value = lm_arrURLParams[i].split("=")[1];
				//jQ
				wpcf7.taggen.update(jQuery(document.getElementById('tag-generator-panel-lm-lm_form')).parents('form:first'))
				ii++;
			}else if(lm_arrURLParams[i].split("=")[0] == 'lm_key'){
				//js
				document.getElementById('tag-generator-panel-lm-lm_key').value = lm_arrURLParams[i].split("=")[1];
				//jQ
				wpcf7.taggen.update(jQuery(document.getElementById('tag-generator-panel-lm-lm_key')).parents('form:first'))
				ii++;
			}else{
				
			}
        }
	}
	if(ii < 2) alert("כתובת לא תקינה, חסרים נתונים.");
	
	
	
}
</script>


<div class="control-box" style="direction: rtl;">
<fieldset>
<legend><?php echo sprintf( esc_html( $description ), $desc_link ); ?></legend>
<table class="form-table" style="direction: ltr;">
<tbody>
	<tr>
		<td colspan="2"><hr/></td>
	</tr>

	<tr>
	<th scope="row"><label for="lm_URL">lm API URL</label></th>
	<td><input style="float:left;" type="text" name="lm_URL" class="tg-name oneline" id="di_lm_sURL" /> <input style="float:left;" class="button" type="button" value="convert" onclick="di_extract_from_string_url();" ></td>
	</tr>
	<tr>
		<td colspan="2">	<p class="description mail-tag" style="float: right; direction: rtl;">כלי להמרת כתובת API. ניתן גם לדלג ולמלא ידנית את השדות שמתחת.</p></td>
	</tr>	
	<tr>
		<td colspan="2"><hr/></td>
	</tr>
	
	<tr>
		<th scope="row">Post method</th>
		<td>
			<fieldset>
			<legend class="screen-reader-text">Post method</legend>
			<select name="tagtype" style="width: 200px">
				<option selected="selected" value="lm">Default - redirect</option>
				<option value="lm_pixel">Pixel embedded</option>
				<option value="lm_iframe">iFrame embedded</option>
				<!--<option value="lm_proxy">Server side (proxy)</option>-->
			</select>
			</fieldset>
		</td>
	</tr>	
	<tr>
		<th scope="row">Use email ?</th>
		<td>
		<fieldset>
			<legend class="screen-reader-text">Use email ?</legend>
			<label><input name="alsosendemail:yes" class="option" type="checkbox" value="on"> Yes - also send email</label><br>
		</fieldset>			
		</td>
	</tr>	
	


	
	
	
	<tr>
		<td colspan="2"><hr/></td>
	</tr>
	<tr>
	<th scope="row"><label for="<?php echo esc_attr( $args['content'] . '-name' ); ?>"><?php echo esc_html( __( 'Name', 'contact-form-7' ) ); ?></label></th>
	<td><input type="text" name="name" class="tg-name oneline" id="<?php echo esc_attr( $args['content'] . '-name' ); ?>" /></td>
	</tr>


	<tr>
	<th scope="row"><label for="<?php echo esc_attr( $args['content'] . '-lm_form' ); ?>"><?php echo esc_html( __( 'lm_form', 'contact-form-7' ) ); ?></label></th>
	<td><input type="text" name="lm_form" class="idvalue oneline option" id="<?php echo esc_attr( $args['content'] . '-lm_form' ); ?>" /></td>
	</tr>

	<tr>
	<th scope="row"><label for="<?php echo esc_attr( $args['content'] . '-lm_key' ); ?>"><?php echo esc_html( __( 'lm_key', 'contact-form-7' ) ); ?></label></th>
	<td><input type="text" name="lm_key" class="classvalue oneline option" id="<?php echo esc_attr( $args['content'] . '-lm_key' ); ?>" /></td>
	</tr>

</tbody>
</table>
</fieldset>
</div>

<div class="insert-box">
	<input id="tag_code" type="text" name="<?php echo $type; ?>" class="tag code" readonly="readonly" onfocus="this.select()" />

	<div class="submitbox">
	<input type="button" class="button button-primary insert-tag" value="<?php echo esc_attr( __( 'Insert Tag', 'contact-form-7' ) ); ?>" />
	</div>

	<br class="clear" />

	<p class="description mail-tag" style="float: right; direction: rtl;">הוספת תגית זו תשגר את הטופס למערכת בהתאם להגדרות שהזנת מעל.</p>
</div>
<?php
	}

	public function wpcf7_add_form_tag_lm() {
		wpcf7_add_form_tag( array('lm', 'lm_pixel','lm_iframe','lm_proxy'),array($this,'wpcf7_add_form_tag_lm_handler'),array('name-attr' => true) );
	}
	public function wpcf7_add_form_tag_lm_handler( $tag ){
		$html = '';
		$html .= sprintf( '<input type="hidden" name="lm_post_method" value="%1$s" />',esc_attr($tag->type) );
		if (isset($tag->options)){
			foreach ((array)$tag->options as $option){
				$segments = explode(':', $option);
				list($name, $value) = $segments;
				$html .= sprintf( '<input type="hidden" name="%1$s" value="%2$s" />',esc_attr($name), esc_attr($value) );
			}
		}
		$di_lm_nonce = wp_create_nonce( 'di_lm_nonce_action' );
		$html .= sprintf('<input type="hidden" name="di_lm_nonce_action" value="%1$s" />',$di_lm_nonce);
		
		$di_lm_get_url_args = lm_session::get_url_args(); //$_GET
		foreach ((array)$di_lm_get_url_args as $key => $value){
			if (substr( $key, 0, 3 ) == "_wp") continue;
			$html .= sprintf( '<input type="hidden" name="%1$s" value="%2$s" />', esc_attr($key),esc_attr($value) );
		}
		return $html;
	}
	
	
	
	
	public function wpcf7_add_shortcode_lm() {
		wpcf7_add_shortcode( array( 'lm', 'lm_pixel','lm_iframe','lm_proxy' ),array($this,'wpcf7_add_shortcode_lm_handler'), true );
	}
	
	public function wpcf7_add_shortcode_lm_handler( $tag ){
		$tag = new WPCF7_Shortcode( $tag );

		if ( empty( $tag->name ) )
			return '';
		
		if (!isset($tag->options))
			return '';
		
		
		$validation_error = wpcf7_get_validation_error( $tag->name );

		$class = wpcf7_form_controls_class( $tag->type );

		if ( $validation_error )
			$class .= ' wpcf7-not-valid';

		$html = '';
		$html .= sprintf( '<input type="hidden" name="lm_post_method" value="%1$s" />', esc_attr( $tag->type ),$validation_error );
		
		foreach ((array)$tag->options as $option){
			$segments = explode(':', $option);
			list($name, $value) = $segments;
			$html .= sprintf( '<input type="hidden" name="%1$s" value="%2$s" />', esc_attr( $name ), esc_attr( $value ),$validation_error );
		}
		
		$di_lm_nonce = wp_create_nonce( 'di_lm_nonce_action' );
		$html .= sprintf('<input type="hidden" name="di_lm_nonce_action" value="%1$s" />',$di_lm_nonce);
		
		$di_lm_get_url_args = lm_session::get_url_args(); //$_GET
		foreach ((array)$di_lm_get_url_args as $key => $value){
			if (substr( $key, 0, 3 ) == "_wp") continue;
			$html .= sprintf( '<input type="hidden" name="%1$s" value="%2$s" />', esc_attr( $key ), esc_attr( $value ) );
		}
		return $html;
	}

}

