<?php
namespace Dugi;

/**
 * @author  Dagan Yaakov <admin@dugi.co.il>
 * @since   08/12/2016
 * @link    http://wp.dugi.co.il
 * @version 1.0.0
 */


class lm_Pojo_Forms_admin{
	public function __construct(){
		add_action( 'add_meta_boxes', function () {
			add_meta_box( 'lm-meta-box', 'LeadManager - התממשקות', array($this,'lm_meta_box_cb'), 'pojo_forms');
		} );
		add_action( 'save_post', array($this,'save_post') );
	}
	
	public function save_post($post_id){
		if (!isset($_POST['lm_pojoforms_metadata_nonce']) || !wp_verify_nonce($_POST['lm_pojoforms_metadata_nonce'], 'lm_pojoforms_metadata')) return;
		if (!isset($_POST['lm_pojoforms_metadata'])) return;
		
		$lm_pojoforms_metadata = (isset($_POST['lm_pojoforms_metadata'])) ? (array)$_POST['lm_pojoforms_metadata'] : array();
		$lm_pojoforms_metadata = array_map('trim',$lm_pojoforms_metadata);
		
		if (isset($lm_pojoforms_metadata['lm_form']) && isset($lm_pojoforms_metadata['lm_key']) && absint($lm_pojoforms_metadata['lm_form']) > 0 ){
			update_post_meta( $post_id, 'lm_pojoforms_metadata', $lm_pojoforms_metadata );
		}else{
			delete_post_meta( $post_id, 'lm_pojoforms_metadata' );
		}
	}
	
	public function lm_meta_box_cb(){
		global $post;
		$lm_pojoforms_metadata = get_post_meta ( $post->ID, 'lm_pojoforms_metadata', true );
		$lm_pojoforms_metadata = ($lm_pojoforms_metadata) ? (array)$lm_pojoforms_metadata : array();
		
		wp_nonce_field( 'lm_pojoforms_metadata', 'lm_pojoforms_metadata_nonce' );
?>
	<table class="form-table">
		<tr>
			<th><label for="di_rest_name">לינק API ליד מנג'ר</label></th>
			<td> 
				<input id="di_lm_sURL" name="lm_api_link" class="regular-text code" type="text" value="" placeholder=""> <input class="button" type="button" value="חלץ שדות" onclick="di_extract_from_string_url();">
			</td>
		</tr>
	</table>
	
	<table class="form-table" id="lm_table">
		<?php 
		foreach ((array)$lm_pojoforms_metadata as $key => $value){
			echo '<tr><th><label>'.$key.'</label></th><td><input name="lm_pojoforms_metadata['.esc_attr($key).']" class="regular-text code" type="text" value="'.esc_attr($value).'"></td></tr>';
		}
		?>
		
	</table>

	<script>
		function di_extract_from_string_url(){
			ii = 0;
			var lm_sURL = document.getElementById('di_lm_sURL').value;
			if (lm_sURL.indexOf("?") > 0) {
				var lm_arrURLParams = lm_sURL.split("?")[1].split("&");
				var lm_arrParamNames = new Array(lm_arrURLParams.length);
				jQuery('#lm_table').html('');
				for (i = 0; i < lm_arrURLParams.length; i++) {
					 if (lm_arrURLParams[i].split("=")[0] == 'lm_form' || lm_arrURLParams[i].split("=")[0] == 'lm_key' || lm_arrURLParams[i].split("=")[0] == 'lm_supplier'){
						ii++;
						jQuery('#lm_table').append('<tr><th><label>'+lm_arrURLParams[i].split("=")[0]+'</label></th><td><input name="lm_pojoforms_metadata['+lm_arrURLParams[i].split("=")[0]+']" class="regular-text code" type="text" value="'+lm_arrURLParams[i].split("=")[1]+'"></td></tr>');
					 }else{
						jQuery('#lm_table').append('<tr><th><label>'+lm_arrURLParams[i].split("=")[0]+' '+lm_arrURLParams[i].split("=")[1]+'</label></th><td><input name="lm_pojoforms_metadata['+lm_arrURLParams[i].split("=")[0]+']" class="regular-text code" type="text"></td></tr>');

					 }
				}
			}
			if(ii < 2) alert("כתובת לא תקינה, חסרים נתונים.");
		}
	</script>
<?php
	}
	

	


}


